'MACRO TITLE: EXPORT MODEL META DATA TO Navision Financials Textfiles
'This macro generates a mini report for the selected entities in the active model.
' REQUIREMENT: none

'----------------------------------------------------------------------------
' Author:			Martin F. Kleindl (mfk@gmx.at)
' Date:				July 2000
'
' Current Version:	V1.000
'----------------------------------------------------------------------------
' Changes:
'
'----------------------------------------------------------------------------

	' Dim MS Word variables.

	Dim Word As Object
	Dim Docs As Object
	Dim WordBasic As Object
	Dim ActiveDoc As Object
	
	' Dim ER/Studio variables.
	
	Dim diag As Diagram
	Dim mdl As Model
	Dim sm As SubModel
	Dim so As SelectedObject
	Dim id As Integer
	Dim ent As Entity
	Dim attr As AttributeObj

	Dim rels As Relationships
	Dim rel As Relationship
	Dim parentity As Entity
	Dim fkpair As FKColumnPair
	Dim datatypetext As String
	Dim keytext As String
	Dim filename As String

	Dim FirstTableNr As	Long
	Dim FirstFieldNr As	Long
	Dim ActFieldNr As Long
	Dim TableStep As Integer
	Dim FieldStep As Integer

	Dim Filenr As Integer
	Dim Filenr2 As Integer
	Dim filetext As String



Sub Main



	'Dialog Window

	Begin Dialog UserDialog 450,287,"Erzeuge Tables fr Navision" ' %GRID:10,7,1,1
		Text 10,14,180,14,"Erste Tabellennummer",.Text1
		Text 10,42,140,14,"Tabellenschrittweite",.Text2
		Text 10,105,180,14,"Feldschrittweite",.Text3
		Text 10,140,180,14,"Aktionen",.Text5
		Text 10,70,160,14,"Erste Feldnummer",.Text4
		TextBox 170,7,90,21,.TextBox1
		TextBox 170,35,90,21,.TextBox2
		TextBox 170,70,90,21,.TextBox3
		TextBox 170,98,90,21,.TextBox4
		OKButton 240,252,90,21
		CancelButton 340,252,90,21
		CheckBox 170,140,140,14,"Erzeuge Tables",.CheckBox1
		CheckBox 170,161,120,14,"Erzeuge Forms",.CheckBox2
		Text 20,210,400,14,"Sie knnen nach diesem Fenster den Dateinamen auswhlen",.Text6
	End Dialog
	Dim dlg As UserDialog
	Dialog dlg


	filename = GetFilePath("NF-Importdatei", "txt", "c:\temp", "Navsion Import Datei")
	Filenr = FreeFile()
	Open (filename & "a") For Output As Filenr
	Filenr2 = FreeFile()

	If (dlg.textbox1 <> "") Then
		FirstTableNr =CLng(dlg.TextBox1)
	Else
		FirstTableNr = 50000
	End If

	If (dlg.textbox2 <> "") Then
		TableStep = CInt(dlg.textbox2)
	Else
		TableStep = 2
	End If

	If (dlg.textbox3 <> "") Then
		FirstFieldNr = CInt(dlg.textbox3)
	Else
		FirstFieldNr = 10
	End If

	If (dlg.textbox4 <> "") Then
		FieldStep = CInt(dlg.textbox4)
	Else
		FieldStep = 10
	End If


	' Init the ER/Studio variables.
	
	Set diag = DiagramManager.ActiveDiagram
	Set mdl = diag.ActiveModel
	Set sm = mdl.ActiveSubModel

	For Each so In sm.SelectedObjects
		If so.Type = 1 Then		' Entities are Type 1 objects.
			If dlg.checkbox1 Then
				Tables
			End If
			If dlg.checkbox2 Then
				Forms
			End If
		End If
		FirstTableNr = FirstTableNr + TableStep
    Next
	Close Filenr

	'Replace characters
	Open (filename ) For Output As Filenr
	Open (filename & "a") For Input As Filenr2
	While Not EOF(Filenr2)
		Line Input #Filenr2, filetext
		filetext = Replace(filetext,"","")
		filetext = Replace(filetext,"","")
		filetext = Replace(filetext,"","")
		filetext = Replace(filetext,"","")
		filetext = Replace(filetext,"","")
		filetext = Replace(filetext,"","")
		filetext = Replace(filetext,"","")
		Print #Filenr, filetext
	Wend
	Close #Filenr
	Close #Filenr2
	Kill (filename & "a")



End Sub


Sub Tables
	' You need the submodel when determining what's selected.
    ' Iterate through all selected objects and process only entities.
    

			' Get the entity.
			id = so.ID
			Set ent = mdl.Entities.Item(id)
			
			' Print NF-Table Block
			Print #Filenr, "OBJECT Table " & FirstTableNr & " " & ent.EntityName 
			Print #Filenr, "{"                                  
			Print #Filenr, "  OBJECT-PROPERTIES"                
			Print #Filenr, "  {"                                
			Print #Filenr, "    Datum=01.01.00;" 				
			Print #Filenr, "    Versions Liste=ER Studio;"      
			Print #Filenr, "  }"                                
            Print #Filenr, "  PROPERTIES"                       
			Print #Filenr, "  {"                                
			Print #Filenr, "    LookupFormID=Form" & FirstTableNr & ";" 
 			Print #Filenr, "    DrillDownFormID=Form" & FirstTableNr & ";" 
            Print #Filenr, "  }"                                
			Print #Filenr, "  FIELDS    "                       
			Print #Filenr, "  {"                                

			' Fields
			' PKs first
			ActFieldNr = FirstFieldNr
			For Each attr In ent.Attributes
				If attr.PrimaryKey Then
					Select Case attr.Datatype
						Case "CHAR"
							datatypetext = "TEXT"
						Case Else
							datatypetext = attr.Datatype
					End Select

					If Not (attr.ForeignKey) Then
						Print #Filenr, "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & "}"
					Else
						'Trace the FK-Table
						For Each rel In ent.ChildRelationships
							For Each fkpair In rel.FKColumnPairs
								If (fkpair.ChildAttribute.ID = attr.ID) Then
									Print #Filenr, "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & " ;TableRelation=" & rel.ParentEntity.EntityName & "." & fkpair.ParentAttribute.AttributeName & " }"
								End If
							Next
						Next
					End If
					ActFieldNr = ActFieldNr + FieldStep
				End If
			Next
			'Attributes
			For Each attr In ent.Attributes
				If Not attr.PrimaryKey Then
					Select Case attr.Datatype
						Case "CHAR"
							datatypetext = "TEXT"
						Case Else
							datatypetext = attr.Datatype
					End Select

					If Not (attr.ForeignKey) Then
						Print #Filenr, "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & "}"
					Else
						'Search the FK-Table
						For Each rel In ent.ChildRelationships
							For Each fkpair In rel.FKColumnPairs
								If (fkpair.ChildAttribute.ID = attr.ID) Then
									Print #Filenr, "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & " ;TableRelation=" & rel.ParentEntity.EntityName & "." & fkpair.ParentAttribute.AttributeName & " }"
								End If
							Next
						Next
					End If
					ActFieldNr = ActFieldNr + FieldStep
				End If
			Next


			'Keys
            Print #Filenr, "  }"
			Print #Filenr, "  KEYS      "                       
			Print #Filenr, "  {"                                

			keytext = ""
			For Each attr In ent.Attributes
				If (attr.PrimaryKey = "True") Then
					keytext = keytext & "," & attr.ColumnName
				End If
			Next
			If Left(keytext,1) = "," Then
				keytext = Mid(keytext,2)
			End If

			Print #Filenr, "    {  ; " & keytext & "}"


			'Closing Block
            Print #Filenr, "  }"                                
			Print #Filenr, "  CODE      "                       
			Print #Filenr, "  {"                                
            Print #Filenr, "    BEGIN"                          
            Print #Filenr, "    // Tables designed with ER/Studio" 
            Print #Filenr, "    // Interface: (c) by MFK for IBS"  
            Print #Filenr, "    END."                           
            Print #Filenr, "  }"                                
			Print #Filenr, "}"                                  
			Print #Filenr, vbCrLf
End Sub


Sub Forms
	' You need the submodel when determining what's selected.
    ' Iterate through all selected objects and process only entities.
    

			' Get the entity.
			id = so.ID
			Set ent = mdl.Entities.Item(id)
			
			' Print NF-Table Block
			Print #Filenr, "OBJECT Form " & FirstTableNr & " " & ent.EntityName 
			Print #Filenr, "{"                                  
			Print #Filenr, "  OBJECT-PROPERTIES"                
			Print #Filenr, "  {"                                
			Print #Filenr, "    Datum=01.01.00;" 				
			Print #Filenr, "    Versions Liste=ER Studio;"      
			Print #Filenr, "  }"                                
            Print #Filenr, "  PROPERTIES"                       
			Print #Filenr, "  {"                                
			Print #Filenr, "    Width=9790;"	 				
			Print #Filenr, "    Height=6710;"				    
			Print #Filenr, "    TableBoxId=1;" 					
			Print #Filenr, "    SourceTable=Table" & FirstTableNr & ";" 
            Print #Filenr, "  }"                                
			Print #Filenr, "  CONTROLS    "                     
			Print #Filenr, "  {"                                
			Print #Filenr, "    { 1 ; TableBox ; 220 ; 220 ; 9350 ; 5500 ; HorzGlue=Both ; VertGlue = Both }" 

			' Fields
			ActFieldNr = 2
			For Each attr In ent.Attributes
				Print #Filenr, "    { " & ActFieldNr & " ; Textbox ; 0 ; 0 ; 2200; 0 ; ParentControl=1 ; InColumn=Ja ; SourceExpr=" & Chr(34) & attr.ColumnName & Chr(34) & "}" 
				ActFieldNr = ActFieldNr + 1
				Print #Filenr, "    { " & ActFieldNr & " ; Label   ; 0 ; 0 ; 0   ; 0 ; ParentControl=" & (ActFieldNr - 1) & "; InColumnHeading=Ja }" 
				ActFieldNr = ActFieldNr + 1
			Next

			Print #Filenr, "    { " & (ActFieldNr + 0) & "; CommandButton ; 2530 ; 5940 ; 2200 ; 550 ; HorzGlue=Right;VertGlue=Bottom;Default=Ja;PushAction=LookupOK;InvalidActionAppearance=Hide }" 
			Print #Filenr, "    { " & (ActFieldNr + 1) & "; CommandButton ; 4950 ; 5940 ; 2200 ; 550 ; HorzGlue=Right;VertGlue=Bottom;Cancel=Ja;PushAction=LookupCancel;InvalidActionAppearance=Hide }" 
			Print #Filenr, "    { " & (ActFieldNr + 2) & "; CommandButton ; 7370 ; 5940 ; 2200 ; 550 ; HorzGlue=Right;VertGlue=Bottom;PushAction=FormHelp }" 

			'Closing Block
            Print #Filenr, "  }"                                
			Print #Filenr, "  CODE      "                       
			Print #Filenr, "  {"                                
            Print #Filenr, "    BEGIN"                          
            Print #Filenr, "    // Forms designed with ER/Studio" 
            Print #Filenr, "    // Interface: (c) by MFK for IBS"  
            Print #Filenr, "    END."                           
            Print #Filenr, "  }"                                
			Print #Filenr, "}"                                  
			Print #Filenr, vbCrLf

End Sub
