'MACRO TITLE: EXPORT MODEL META DATA TO Navision Financials Textfiles
'This macro generates a mini report for the selected entities in the active model.
' REQUIREMENT: You must have Word 97 installed.

'----------------------------------------------------------------------------
' Author:			Martin F. Kleindl (mfk@gmx.at)
' Date:				July 2000
'
' Current Version:	V1.000
'----------------------------------------------------------------------------
' Changes:
'
'----------------------------------------------------------------------------

	' Dim MS Word variables zzz.

	Dim Word As Object
	Dim Docs As Object
	Dim WordBasic As Object
	Dim ActiveDoc As Object
	
	' Dim ER/Studio variables.
	
	Dim diag As Diagram
	Dim mdl As Model
	Dim sm As SubModel
	Dim so As SelectedObject
	Dim id As Integer
	Dim ent As Entity
	Dim attr As AttributeObj

	Dim rels As Relationships
	Dim rel As Relationship
	Dim parentity As Entity
	Dim fkpair As FKColumnPair
	Dim datatypetext As String
	Dim keytext As String
	Dim filename As String

	Dim FirstTableNr As	Long
	Dim	FirstFieldnr As Long
	Dim ActFieldNr As Long
	Dim TableStep As Integer
	Dim FieldStep As Integer


Sub Main



	'Dialog

	Begin Dialog UserDialog 450,287,"Erzeuge Tables fr Navision" ' %GRID:10,7,1,1
		Text 10,14,180,14,"Erste Tabellennummer",.Text1
		Text 10,42,140,14,"Tabellenschrittweite",.Text2
		Text 10,105,180,14,"Feldschrittweite",.Text3
		Text 10,140,180,14,"Aktionen",.Text5
		Text 10,70,160,14,"Erste Feldnummer",.Text4
		TextBox 170,7,90,21,.TextBox1
		TextBox 170,35,90,21,.TextBox2
		TextBox 170,70,90,21,.TextBox3
		TextBox 170,98,90,21,.TextBox4
		OKButton 240,252,90,21
		CancelButton 340,252,90,21
		CheckBox 170,140,140,14,"Erzeuge Tables",.CheckBox1
		CheckBox 170,161,120,14,"Erzeuge Forms",.CheckBox2
		'Text 20,210,400,14,"Sie knnen nach diesem Fenster den Dateinamen auswhlen",.Text6
	End Dialog
	Dim dlg As UserDialog
	Dialog dlg

	'filename = GetFilePath("NF-Importdatei", "txt", "c:\temp", "Navsion Import Datei")

	If (dlg.textbox1 <> "") Then
		FirstTableNr =CLng(dlg.TextBox1)
	Else
		FirstTableNr = 50000
	End If

	If (dlg.textbox2 <> "") Then
		TableStep = CInt(dlg.textbox2)
	Else
		TableStep = 2
	End If

	If (dlg.textbox3 <> "") Then
		FirstFieldnr = CInt(dlg.textbox3)
	Else
		FirstFieldnr = 10
	End If

	If (dlg.textbox4 <> "") Then
		FieldStep = CInt(dlg.textbox4)
	Else
		FieldStep = 10
	End If


	' Start MS Word and make it visible.

	Set Word = CreateObject("Word.Application")
	Word.Visible = True
	Word.Options.CheckGrammarAsYouType = False
	Word.Options.CheckSpellingAsYouType = False
	Word.Documents.Add
	Set ActiveDoc = Word.Documents(1)
	ActiveDoc.Activate

	' Init the ER/Studio variables.
	
	Set diag = DiagramManager.ActiveDiagram
	Set mdl = diag.ActiveModel
	Set sm = mdl.ActiveSubModel

	For Each so In sm.SelectedObjects
		If so.Type = 1 Then		' Entities are Type 1 objects.
			If dlg.checkbox1 Then
				Tables
			End If
			If dlg.checkbox2 Then
				Forms
			End If
		End If
		FirstTableNr = FirstTableNr + TableStep
    Next



End Sub


Sub Tables
	' You need the submodel when determining what's selected.
    ' Iterate through all selected objects and process only entities.
    

			' Get the entity.
			id = so.ID
			Set ent = mdl.Entities.Item(id)
			
			' Write NF-Table Block
			Word.Selection.TypeText Text:= "OBJECT Table " & FirstTableNr & " " & ent.EntityName & vbCrLf
			Word.Selection.TypeText Text:= "{"                                  & vbCrLf
			Word.Selection.TypeText Text:= "  OBJECT-PROPERTIES"                & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
			Word.Selection.TypeText Text:= "    Datum=01.01.00;" 				& vbCrLf
			Word.Selection.TypeText Text:= "    Versions Liste=ER Studio;"      & vbCrLf
			Word.Selection.TypeText Text:= "  }"                                & vbCrLf
            Word.Selection.TypeText Text:= "  PROPERTIES"                       & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
			Word.Selection.TypeText Text:= "    LookupFormID=Form" & FirstTableNr & ";" & vbCrLf
 			Word.Selection.TypeText Text:= "    DrillDownFormID=Form" & FirstTableNr & ";" & vbCrLf
            Word.Selection.TypeText Text:= "  }"                                & vbCrLf
			Word.Selection.TypeText Text:= "  FIELDS    "                       & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf

			' Fields
			' PKs
			ActFieldNr = FirstFieldnr
			For Each attr In ent.Attributes
				If attr.PrimaryKey Then
					Select Case attr.Datatype
						Case "CHAR"
							datatypetext = "TEXT"
						Case Else
							datatypetext = attr.Datatype
					End Select

					If Not (attr.ForeignKey) Then
						Word.Selection.TypeText Text:= "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & "}" & vbCrLf
					Else
						Word.Selection.TypeText Text:= "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & " ;TableRelation="
						'Search FK-Table
						For Each rel In ent.ChildRelationships
							For Each fkpair In rel.FKColumnPairs
								If (fkpair.ChildAttribute.ID = attr.ID) Then
									Word.Selection.TypeText Text := rel.ParentEntity.EntityName & "." & fkpair.ParentAttribute.AttributeName
								End If
							Next
						Next
						Word.Selection.TypeText Text :=  " }" & vbCrLf
					End If
					ActFieldNr = ActFieldNr + FieldStep
				End If
			Next
			' Attributes
			For Each attr In ent.Attributes
				If Not attr.PrimaryKey Then
					Select Case attr.Datatype
						Case "CHAR"
							datatypetext = "TEXT"
						Case Else
							datatypetext = attr.Datatype
					End Select

					If Not (attr.ForeignKey) Then
						Word.Selection.TypeText Text:= "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & "}" & vbCrLf
					Else
						Word.Selection.TypeText Text:= "    { " & ActFieldNr & " ; ;" & attr.ColumnName & " ;" & datatypetext & attr.DataLength & " ;TableRelation="
						'Search the FK-Table
						For Each rel In ent.ChildRelationships
							For Each fkpair In rel.FKColumnPairs
								If (fkpair.ChildAttribute.ID = attr.ID) Then
									Word.Selection.TypeText Text := rel.ParentEntity.EntityName & "." & fkpair.ParentAttribute.AttributeName
								End If
							Next
						Next
						Word.Selection.TypeText Text :=  " }" & vbCrLf
					End If
					ActFieldNr = ActFieldNr + FieldStep
				End If
			Next


			'Keys
            Word.Selection.TypeText Text:= "  }"                                & vbCrLf
			Word.Selection.TypeText Text:= "  KEYS      "                       & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
			Word.Selection.TypeText Text:= "    {  ; "

			keytext = ""
			For Each attr In ent.Attributes
				If (attr.PrimaryKey = "True") Then
					keytext = keytext & "," & attr.ColumnName
				End If
			Next
			If Left(keytext,1) = "," Then
				keytext = Mid(keytext,2)
			End If

			Word.Selection.TypeText Text:= keytext & "}" & vbCrLf

			'Closing Block
            Word.Selection.TypeText Text:= "  }"                                & vbCrLf
			Word.Selection.TypeText Text:= "  CODE      "                       & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
            Word.Selection.TypeText Text:= "    BEGIN"                          & vbCrLf
            Word.Selection.TypeText Text:= "    // Tables designed with ER/Studio" & vbCrLf
            Word.Selection.TypeText Text:= "    // Interface: (c) by MFK for IBS"  & vbCrLf
            Word.Selection.TypeText Text:= "    END."                           & vbCrLf
            Word.Selection.TypeText Text:= "  }"                                & vbCrLf
			Word.Selection.TypeText Text:= "}"                                  & vbCrLf
			Word.Selection.TypeText Text:= vbCrLf
End Sub


Sub Forms
	' You need the submodel when determining what's selected.
    ' Iterate through all selected objects and process only entities.
    

			' Get the entity.
			id = so.ID
			Set ent = mdl.Entities.Item(id)
			
			' Write NF-Table Block
			Word.Selection.TypeText Text:= "OBJECT Form " & FirstTableNr & " " & ent.EntityName & vbCrLf
			Word.Selection.TypeText Text:= "{"                                  & vbCrLf
			Word.Selection.TypeText Text:= "  OBJECT-PROPERTIES"                & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
			Word.Selection.TypeText Text:= "    Datum=01.01.00;" 				& vbCrLf
			Word.Selection.TypeText Text:= "    Versions Liste=ER Studio;"      & vbCrLf
			Word.Selection.TypeText Text:= "  }"                                & vbCrLf
            Word.Selection.TypeText Text:= "  PROPERTIES"                       & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
			Word.Selection.TypeText Text:= "    Width=9790;"	 				& vbCrLf
			Word.Selection.TypeText Text:= "    Height=6710;"				    & vbCrLf
			Word.Selection.TypeText Text:= "    TableBoxId=1;" 					& vbCrLf
			Word.Selection.TypeText Text:= "    SourceTable=Table" & FirstTableNr & ";" & vbCrLf
            Word.Selection.TypeText Text:= "  }"                                & vbCrLf
			Word.Selection.TypeText Text:= "  CONTROLS    "                     & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
			Word.Selection.TypeText Text:= "    { 1 ; TableBox ; 220 ; 220 ; 9350 ; 5500 ; HorzGlue=Both ; VertGlue = Both }" & vbCrLf

			' Fields
			ActFieldNr = 2
			For Each attr In ent.Attributes
				Word.Selection.TypeText Text:= "    { " & ActFieldNr & " ; Textbox ; 0 ; 0 ; 2200; 0 ; ParentControl=1 ; InColumn=Ja ; SourceExpr=" & Chr(34) & attr.ColumnName & Chr(34) & "}" & vbCrLf
				ActFieldNr = ActFieldNr + 1
				Word.Selection.TypeText Text:= "    { " & ActFieldNr & " ; Label   ; 0 ; 0 ; 0   ; 0 ; ParentControl=" & (ActFieldNr - 1) & "; InColumnHeading=Ja }" & vbCrLf
				ActFieldNr = ActFieldNr + 1
			Next

			Word.Selection.TypeText Text:= "    { " & (ActFieldNr + 0) & "; CommandButton ; 2530 ; 5940 ; 2200 ; 550 ; HorzGlue=Right;VertGlue=Bottom;Default=Ja;PushAction=LookupOK;InvalidActionAppearance=Hide }" & vbCrLf
			Word.Selection.TypeText Text:= "    { " & (ActFieldNr + 1) & "; CommandButton ; 4950 ; 5940 ; 2200 ; 550 ; HorzGlue=Right;VertGlue=Bottom;Cancel=Ja;PushAction=LookupCancel;InvalidActionAppearance=Hide }" & vbCrLf
			Word.Selection.TypeText Text:= "    { " & (ActFieldNr + 2) & "; CommandButton ; 7370 ; 5940 ; 2200 ; 550 ; HorzGlue=Right;VertGlue=Bottom;PushAction=FormHelp }" & vbCrLf

			'Closing Block
            Word.Selection.TypeText Text:= "  }"                                & vbCrLf
			Word.Selection.TypeText Text:= "  CODE      "                       & vbCrLf
			Word.Selection.TypeText Text:= "  {"                                & vbCrLf
            Word.Selection.TypeText Text:= "    BEGIN"                          & vbCrLf
            Word.Selection.TypeText Text:= "    // Forms designed with ER/Studio" & vbCrLf
            Word.Selection.TypeText Text:= "    // Interface: (c) by MFK for IBS"  & vbCrLf
            Word.Selection.TypeText Text:= "    END."                           & vbCrLf
            Word.Selection.TypeText Text:= "  }"                                & vbCrLf
			Word.Selection.TypeText Text:= "}"                                  & vbCrLf
			Word.Selection.TypeText Text:= vbCrLf

End Sub
